searchNodes=[{"doc":"","ref":"Mix.Tasks.Singyeong.Package.html","title":"Mix.Tasks.Singyeong.Package","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Singyeong.Package.html#run/1","title":"Mix.Tasks.Singyeong.Package.run/1","type":"function"},{"doc":"The base plugin behaviour. Your plugin should only have one module implementing this behaviour. Note that this behaviour is explicitly, intentionally NOT implemented as a GenServer or similar! You are, of course, free to implement all the callbacks in this module as just GenServer.call(me, :whatever), but this is not going to be explicitly supported by this behaviour. The reasoning for this is that it&#39;s significantly easier for runtime checks as to whether a callback is implemented or not if the behaviour isn&#39;t implemented as a GenServer-like module. Of course, plugin capabilities exist to help deal with this concern, but I find that it&#39;s easier to simply not take that risk and enforce a certain implementation style rather than risking potential runtime crashes due to capabilities being claimed without implementation.","ref":"Singyeong.Plugin.html","title":"Singyeong.Plugin","type":"behaviour"},{"doc":"Called when a client identifies with the server. The auth string the client sends, as well as the client&#39;s IP address, are passed to this function. Note that there is no guarantee of IPv4 vs IPv6 address, and your code should be able to handle both cases. Requires the :auth capability.","ref":"Singyeong.Plugin.html#c:auth/2","title":"Singyeong.Plugin.auth/2","type":"callback"},{"doc":"Behaves like undo/2, but for handle_global_event/3. See the docs for handle_global_event/3 for caveats to be aware of.","ref":"Singyeong.Plugin.html#c:global_undo/3","title":"Singyeong.Plugin.global_undo/3","type":"callback"},{"doc":"Called when this plugin is supposed to handle an event. The events passed to this function are those specified in Manifest.events only. Built-in events will never be passed to this function. Requires the :custom_events capability. Plugin event handling behaves in a middleware-type fashion. A plugin can choose to pass execution to the next plugin in the chain via :next, halt execution with :halt, or return an error. Returning an error immediately halts execution and unwinds as much as possible. Halting will immediately stop processing of the event, and will not return anything to the client, as it is assumed that the halted execution was not meant to return any side-effects to the client. On success, this function returns a tuple starting with either :next or :halt In non-halt cases, the third return element is the undo state. This is some state that the plugin uses to undo any stateful changes it may have made during the processing of this event, such that any error can result in a rollback of stateful changes. Pure functions may simply return nil for the undo state, or just not include it as an element of the tuple. Note that a nil undo state is assumed to mean that this function has nothing to undo, and as such the undo function for this module will never be called if the event handled by this function requires undo! That is, returning an undo state of nil means that your undo function will never be called. The reason for this is simply that the order in which handle_event vs undo is called cannot be guaranteed, and so you cannot rely on strict ordering of these function calls for reliable undo behaviour. TODO: Provide a real interface for listening on all events.","ref":"Singyeong.Plugin.html#c:handle_event/2","title":"Singyeong.Plugin.handle_event/2","type":"callback"},{"doc":"Behaves like handle_event/2, with several caveats: Undo is handled by global_undo/3. The frame returned should be the same frame as was passed in, with any necessary modifications. A list of frames cannot be returned, only a single frame. This function is called BEFORE the rest of the event processing pipeline. This function is aware of the &quot;directionality&quot; of an event, that is, this function receives an argument telling it whether the direction of the event is to the :client or to the :server. This argument is also passed to global_undo/3. This function is for events only, not all payloads. Payloads such as identify, heartbeat, ... will not ever be passed to this function.","ref":"Singyeong.Plugin.html#c:handle_global_event/3","title":"Singyeong.Plugin.handle_global_event/3","type":"callback"},{"doc":"Called when the plugin is first loaded. Returns a list of children to be added to the initial supervision tree.","ref":"Singyeong.Plugin.html#c:load/0","title":"Singyeong.Plugin.load/0","type":"callback"},{"doc":"Provides information about the plugin. This is cached when the plugin is loaded.","ref":"Singyeong.Plugin.html#c:manifest/0","title":"Singyeong.Plugin.manifest/0","type":"callback"},{"doc":"Called when this plugin is supposed to undo some stateful changes. Implementations of this function are expected to be impure, and may do more or less whatever they want. The undo_state parameter may be any value, with the exception that a nil undo state will never be passed to this function, for any reason.","ref":"Singyeong.Plugin.html#c:undo/2","title":"Singyeong.Plugin.undo/2","type":"callback"},{"doc":"","ref":"Singyeong.Plugin.html#t:auth_string/0","title":"Singyeong.Plugin.auth_string/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.html#t:direction/0","title":"Singyeong.Plugin.direction/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.html#t:event/0","title":"Singyeong.Plugin.event/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.html#t:frame/0","title":"Singyeong.Plugin.frame/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.html#t:ip/0","title":"Singyeong.Plugin.ip/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.html#t:payload/0","title":"Singyeong.Plugin.payload/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.html#t:undo_state/0","title":"Singyeong.Plugin.undo_state/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.Capabilities.html","title":"Singyeong.Plugin.Capabilities","type":"module"},{"doc":"","ref":"Singyeong.Plugin.Capabilities.html#capabilities/0","title":"Singyeong.Plugin.Capabilities.capabilities/0","type":"function"},{"doc":"","ref":"Singyeong.Plugin.Capabilities.html#is_capability?/1","title":"Singyeong.Plugin.Capabilities.is_capability?/1","type":"function"},{"doc":"","ref":"Singyeong.Plugin.Constants.html","title":"Singyeong.Plugin.Constants","type":"module"},{"doc":"","ref":"Singyeong.Plugin.Constants.html#gateway_opcodes/0","title":"Singyeong.Plugin.Constants.gateway_opcodes/0","type":"function"},{"doc":"","ref":"Singyeong.Plugin.Constants.html#gateway_opcodes_by_name/0","title":"Singyeong.Plugin.Constants.gateway_opcodes_by_name/0","type":"function"},{"doc":"","ref":"Singyeong.Plugin.Manifest.html","title":"Singyeong.Plugin.Manifest","type":"module"},{"doc":"","ref":"Singyeong.Plugin.Manifest.html#t:t/0","title":"Singyeong.Plugin.Manifest.t/0","type":"type"},{"doc":"","ref":"Singyeong.Plugin.Payload.html","title":"Singyeong.Plugin.Payload","type":"module"},{"doc":"","ref":"Singyeong.Plugin.Payload.html#create_payload/2","title":"Singyeong.Plugin.Payload.create_payload/2","type":"function"},{"doc":"","ref":"Singyeong.Plugin.RestRoute.html","title":"Singyeong.Plugin.RestRoute","type":"module"},{"doc":"","ref":"Singyeong.Plugin.RestRoute.html#t:t/0","title":"Singyeong.Plugin.RestRoute.t/0","type":"type"},{"doc":"A helper module to make Rustler-based natives load properly. defmodule MyNatives do use Singyeong.Plugin.Rustler, crate: &quot;mynatives_native&quot; # or: # use Singyeong.Plugin.Rustler, crate: &quot;&quot;, load_data: 0 # # load_data is passed to :erlang.load_nif/2 end","ref":"Singyeong.Plugin.Rustler.html","title":"Singyeong.Plugin.Rustler","type":"module"},{"doc":"신경 plugin A library that provides the plugin API for 신경. This library is not useful on its own, and must be used alongside a 신경 instance. An example plugin can be found here: https://github.com/queer/singyeong-test-plugin","ref":"readme.html","title":"신경 plugin","type":"extras"},{"doc":"Get it on Hex. def deps do [ {:singyeong_plugin, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"신경 plugin - Installation","type":"extras"},{"doc":"Simply implement the Singyeong.Plugin behaviour in your plugin module. An example of how to do this can be found here: https://github.com/queer/singyeong-test-plugin/blob/master/lib/singyeong_plugin_test.ex Once your plugin is ready, run the following commands: $ mix compile $ mix singyeong.package and a zip file containing your plugin will be created. To use the plugin you created, simply create a plugins/ directory at your 신경 instance&#39;s root directory, and copy the plugin zip into that directory.","ref":"readme.html#creating-a-plugin","title":"신경 plugin - Creating a plugin","type":"extras"},{"doc":"신경 plugins officially support NIFs implemented with Rustler. Other NIF libraries are unsupported and may break at any time, or simply never work. Note that Rustler-based NIFs require some extra steps to be properly 신경-compatible: Your NIF module should have use Singyeong.Plugin.Rustler, crate: &quot;crate_name&quot; instead of use Rustler, otp_app: :my_app, crate: &quot;crate_name&quot;. That&#39;s it! (Note: this may change in the future)","ref":"readme.html#native-code","title":"신경 plugin - Native code","type":"extras"},{"doc":"The following files should be added to your .gitignore: /work /*.zip If using (Rustler) natives: /priv/native /native/*/target /native/*/.cargo","ref":"readme.html#gitignore","title":"신경 plugin - .gitignore","type":"extras"}]